import numpy as np
import pandas as pd
import SimulationData as SD
import Utils

#remove some rendundant edges (simple PC: based on CI test)
#input
#Clu: impure cluster, order has been identified
#Confounder: the measured variable of confounder of Impure cluster Clu
#length_CS: the max length of conditional set
#output:
#Rendundant:some redundant edges that need to remove
#clu is impure, and len>=3
def Remove_Rendundant(Clu,Confounder,LatentIndex,data,length_CS=2):
    print(Clu,Confounder,LatentIndex)
    Rendundant=[]
    Confounder_index=Confounder.copy()
    for i in range(0,len(Clu)):
        L1=Clu[i]
        if i+1 >= len(Clu):
            break
        for j in range(i+1,len(Clu)):
            L2=Clu[j]
            condition_set=[]
            for t in range(0,len(Clu)):
                if t!= i and t!=j:
                    condition_set.append(t)

            #assume the condition set with impure cluster less than 2
            for clen in range(1,length_CS):
                c_set=Utils.FindCombination(condition_set,clen)
                for cs in c_set:
                    cs=list(cs)
                    LQ=[]
                    for t in cs:
                        LQ.append(Clu[t])

                flag=False

                if CItest(L1,L2,LQ,Confounder,LatentIndex,data):
                    Rendundant.append([L1,L2])
                    flag=True
                    break

            if flag:
                flag=False
                break
    print('Rendundant edges are',Rendundant)
    return Rendundant




#conditional independet test with latent variable according to (Theorem 19,Silva et al., 2006)
#input:
#L1,L2: two latent variable hope to test
#Lq:conditional set
#LatentIndex: latent index
#data:dataset of observed variable, DataFrame
#Threshold: Threshold below which SVD values are considered zero in the rank test
def CItest(L1,L2,LQ,Confounder,LatentIndex,data,Threshold=0.1):
    L1_Measured=LatentIndex[L1]
    L2_Measured=LatentIndex[L2]
    Xq=[]
    for i in LQ:
        temp=LatentIndex[i]
        for j in range(0,2):
            Xq.append(temp[j])

    for j in Confounder:
        Xq.append(j)
    len_Q=len(LQ)

    Corr_index=[]
    Corr_index.append(L1_Measured[0])
    Corr_index.append(L2_Measured[0])
    for i in Xq:
        Corr_index.append(i)

    #estimate the correlation matrix of Corr_index and the rank
    tdata=data[Corr_index]
    #transfer to matrix
    matrix=np.mat(tdata.corr())

    rank=np.linalg.matrix_rank(matrix,tol=Threshold)
    print(rank,len_Q+1)
    if rank <= len_Q+1:#exist confounder, so plus one
        return True
    else:
        return False


